<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfExchangeOutEventData ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfExchangeOutEventData
 * @subpackage Arrays
 */
class ArrayOfExchangeOutEventData extends AbstractStructArrayBase
{
    /**
     * The ExchangeOutEventData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\ExchangeOutEventData[]
     */
    public $ExchangeOutEventData;
    /**
     * Constructor method for ArrayOfExchangeOutEventData
     * @uses ArrayOfExchangeOutEventData::setExchangeOutEventData()
     * @param \patest\StructType\ExchangeOutEventData[] $exchangeOutEventData
     */
    public function __construct(array $exchangeOutEventData = array())
    {
        $this
            ->setExchangeOutEventData($exchangeOutEventData);
    }
    /**
     * Get ExchangeOutEventData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\ExchangeOutEventData[]|null
     */
    public function getExchangeOutEventData()
    {
        return isset($this->ExchangeOutEventData) ? $this->ExchangeOutEventData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setExchangeOutEventData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setExchangeOutEventData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateExchangeOutEventDataForArrayConstraintsFromSetExchangeOutEventData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfExchangeOutEventDataExchangeOutEventDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfExchangeOutEventDataExchangeOutEventDataItem instanceof \patest\StructType\ExchangeOutEventData) {
                $invalidValues[] = is_object($arrayOfExchangeOutEventDataExchangeOutEventDataItem) ? get_class($arrayOfExchangeOutEventDataExchangeOutEventDataItem) : sprintf('%s(%s)', gettype($arrayOfExchangeOutEventDataExchangeOutEventDataItem), var_export($arrayOfExchangeOutEventDataExchangeOutEventDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ExchangeOutEventData property can only contain items of type \patest\StructType\ExchangeOutEventData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ExchangeOutEventData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\ExchangeOutEventData[] $exchangeOutEventData
     * @return \patest\ArrayType\ArrayOfExchangeOutEventData
     */
    public function setExchangeOutEventData(array $exchangeOutEventData = array())
    {
        // validation for constraint: array
        if ('' !== ($exchangeOutEventDataArrayErrorMessage = self::validateExchangeOutEventDataForArrayConstraintsFromSetExchangeOutEventData($exchangeOutEventData))) {
            throw new \InvalidArgumentException($exchangeOutEventDataArrayErrorMessage, __LINE__);
        }
        if (is_null($exchangeOutEventData) || (is_array($exchangeOutEventData) && empty($exchangeOutEventData))) {
            unset($this->ExchangeOutEventData);
        } else {
            $this->ExchangeOutEventData = $exchangeOutEventData;
        }
        return $this;
    }
    /**
     * Add item to ExchangeOutEventData value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\ExchangeOutEventData $item
     * @return \patest\ArrayType\ArrayOfExchangeOutEventData
     */
    public function addToExchangeOutEventData(\patest\StructType\ExchangeOutEventData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\ExchangeOutEventData) {
            throw new \InvalidArgumentException(sprintf('The ExchangeOutEventData property can only contain items of type \patest\StructType\ExchangeOutEventData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ExchangeOutEventData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\ExchangeOutEventData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\ExchangeOutEventData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\ExchangeOutEventData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\ExchangeOutEventData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\ExchangeOutEventData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ExchangeOutEventData
     */
    public function getAttributeName()
    {
        return 'ExchangeOutEventData';
    }
}
